unit Aliases;

interface

{$ifdef Win32}
{$H+}
{$endif}

 uses Types, StdFunc
{$ifndef WIN32}
  , Use32
{$endif};

 const
{Aliases for configuration file}
  sFromAddress    : string [11] = 'FROMADDRESS';
  cFromAddress    {: byte} = 1;
  sFromName       : string [8]  = 'FROMNAME';
  cFromName       {: byte} = 2;
  sToAddress      : string [9]  = 'TOADDRESS';
  cToAddress      {: byte} = 3;
  sToName         : string [6]  = 'TONAME';
  cToName         {: byte} = 4;
  sSubject        : string [7]  = 'SUBJECT';
  cSubject        {: byte} = 5;
  sAreaPath       : string [8]  = 'AREAPATH';
  cAreaPath       {: byte} = 6;
  sDefZone        : string [7]  = 'DEFZONE';
  cDefZone        {: byte} = 7;
  sFileBoxes      : string [9]  = 'FILEBOXES';
  cFileBoxes      {: byte} = 9;
  sLongFileBoxes  : string [13] = 'LONGFILEBOXES';
  cLongFileBoxes  {: byte} = 10;
  sBSO            : string [3]  = 'BSO';
  cBSO            {: byte} = 11;
  sLongBSO        : string [7]  = 'LONGBSO';
  cLongBSO        {: byte} = 12;
  sLogFile        : string [7]  = 'LOGFILE';
  cLogFile        {: byte} = 13;
  sLogState       : string [8]  = 'LOGSTATE';
  cLogState       {: byte} = 14;
  sLogFormat      : string [9]  = 'LOGFORMAT';
  cLogFormat      {: byte} = 15;
  sTemplate       : string [8]  = 'TEMPLATE';
  cTemplate       {: byte} = 16;
  sSorting        : string [7]  = 'SORTING';
  cSorting        {: byte} = 17;
  sUserName       : string [8]  = 'USERNAME';
  cUSERName       {: byte} = 18;
  sSkipBusyFlag   : string [12] = 'SKIPBUSYFLAG';
  cSkipBusyFlag   {: byte} = 19;
  sEmptyPackAsPoll: string [15] = 'EMPTYPACKASPOLL';
  cEmptyPackAsPoll{: byte} = 20;
  sOrigin         : string [6]  = 'ORIGIN';
  cOrigin         {: byte} = 21;
  sMainAddress    : string [11] = 'MAINADDRESS';
  cMainAddress    {: byte} = 22;
  sSysOp          : string [5]  = 'SYSOP';
  cSysOp          {: byte} = 23;
  sRegKey         : string [6]  = 'REGKEY';
  cRegKey         {: byte} = 24;
  sTMail_Packets  : string [14] = 'T-MAIL_PACKETS';
  cTMail_Packets  {: byte} = 25;
  sAADateTime     : string [10] = 'AADATETIME';
  cAADateTime     {: byte} = 27;

{Messages story aliases}                  {Priority}
  sPKT    : string [3] = 'PKT';           {1}
  cPKT    {: byte} = 20;
  sNetMail: string [7] = 'NETMAIL';       {4}
  cNetMail{: byte} = 23;
  sMSG    : string [3] = 'MSG';           {5}
  cMSG    {: byte} = 24;
  sFile   : string [4] = 'FILE';          {7}
  cFile   {: byte} = 26;

{LogFile State aliases}
  sRewrite: string [7] = 'REWRITE';
  cRewrite{: byte} = 40;
  sAppend : string [6] = 'APPEND';
  cAppend {: byte} = 41;
  sConsole: string [7] = 'CONSOLE';
  cConsole{: byte} = 42;

{LogFile Format aliases}
  sNormal    : string [6] = 'NORMAL';
  cNormal    {: byte} = 50;
  sDebug     : string [5] = 'DEBUG';
  cDebug     {: byte} = 51;
  sCrashDebug: string [6] = 'DETAIL';
  cCrashDebug{: byte} = 52;
  sAll       : string [3] = 'ALL';
  cAll       {: byte} = 53;

{Aliases of type sorting}
  sSize    : string [4] = 'SIZE';
  cSize    {: byte} = 60;
  sNode    : string [4] = 'NODE';
  cNode    {: byte} = 61;
  sDays    : string [4] = 'DAYS';
  cDays    {: byte} = 62;
  sDaysSize: string [9] = 'DAYS&SIZE';
  cDaysSize{: byte} = 63;
  sDaysNode: string [9] = 'DAYS&NODE';
  cDaysNode{: byte} = 64;

{Logic aliases}
  sYes: string [3] = 'YES';
  cYes{: byte} = 70;
  sNo : string [2] = 'NO';
  cNo {: byte} = 71;

 function GetAliasID (Data: string): byte;
 function GetParam (Data: string): string;
 function GetAddress (Data: string; var Addr: t4D): boolean;

implementation

 function GetAliasID (Data: string): byte;
 var i: word;
     D: string;
 begin
  Data:= DelFirstSpace (Data);
  if (Data = '') or (Data [1] = ';') then begin
   GetAliasID:= 00;
   Exit;
  end;
  i:= 0;
  while (Data [i + 1] <> ' ') and (i + 1 < Length (Data)) do Inc (i);
  D:= UpStr (Copy (Data, 1, i));
  GetAliasID:= $FF;
  if D = sFromAddress     then GetAliasID:= cFromAddress    ;
  if D = sFromName        then GetAliasID:= cFromName       ;
  if D = sToAddress       then GetAliasID:= cToAddress      ;
  if D = sToName          then GetAliasID:= cToName         ;
  if D = sSubject         then GetAliasID:= cSubject        ;
  if D = sAreaPath        then GetAliasID:= cAreaPath       ;
  if D = sDefZone         then GetAliasID:= cDefZone        ;
  if D = sFileBoxes       then GetAliasID:= cFileBoxes      ;
  if D = sLongFileBoxes   then GetAliasID:= cLongFileBoxes  ;
  if D = sBSO             then GetAliasID:= cBSO            ;
  if D = sLongBSO         then GetAliasID:= cLongBSO        ;
  if D = sLogFile         then GetAliasID:= cLogFile        ;
  if D = sLogState        then GetAliasID:= cLogState       ;
  if D = sLogFormat       then GetAliasID:= cLogFormat      ;
  if D = sTemplate        then GetAliasID:= cTemplate       ;
  if D = sSorting         then GetAliasID:= cSorting        ;
  if D = sUserName        then GetAliasID:= cUserName       ;
  if D = sSkipBusyFlag    then GetAliasID:= cSkipBusyFlag   ;
  if D = sEmptyPackAsPoll then GetAliasID:= cEmptyPackAsPoll;
  if D = sOrigin          then GetAliasID:= cOrigin         ;
  if D = sMainAddress     then GetAliasID:= cMainAddress    ;
  if D = sSysOp           then GetAliasID:= cSysOp          ;
  if D = sRegKey          then GetAliasID:= cRegKey         ;
  if D = sTMail_Packets   then GetAliasID:= cTMail_Packets  ;
  if D = sAADateTime      then GetAliasID:= cAADateTime     ;
 end;

 function GetParam (Data: string): string;
 var i: word;
 begin
  GetParam:= '';
  Data:= DelFirstSpace (Data);
  if (Data = '') or (Data = ';') then Exit;
  i:= 1;
  while (Data [i] <> ' ') and (i < Length (Data))  do Inc (i);
  if (i <= Length (Data)) and (Data [i] = ' ') then
   GetParam:= DelLastSpace (DelComment (DelFirstSpace (Copy (Data, i, Length (Data) - i + 1))));
 end;

 function GetAddress (Data: string; var Addr: t4D): boolean;
 var T: string;
     e: longint;
     i: byte;
     b: byte;
 begin
  GetAddress:= False;
  Data:= GetParam (Data);
  if Data = '' then Exit;
  ClearAddr (Addr);
  i:= 1;
  b:= 1;
  while (Data [i] <> ':') and (i < Length (Data)) do Inc (i);
  if i = Length (Data) then Exit;
  Val (Copy (Data, b, i - 1), Addr [0], e);
  b:= i+1;
  i:= 0;
  while (Data [b+i] <> '/') and (i < Length (Data)) do Inc (i);
  if i = Length (Data) then Exit;
  Val (Copy (Data, b, i), Addr [1], e);
  b:= b+i+1;
  i:= 0;
  while (Data [b+i] <> '.') and (i < Length (Data)) do Inc (i);
  if i = Length (Data) then Exit;
  Val (Copy (Data, b, i), Addr [2], e);
  b:= b+i+1;
  i:= Length (Data) - b + 2;
  Val (Copy (Data, b, i), Addr [3], e);
  GetAddress:= True;
 end;

end.
