unit Config;

interface

{$ifdef Win32}
{$H+}
{$endif}

 uses Aliases, Errors, Types, Messages, FileNms, WriteF
{$ifdef WIN32}
  , Windows
{$endif};

 type
  tPassword = string [8];
  tArea = record
   MSGType : byte;              { ଠ ᠣ }
   Path    : string;            {    }
   ID      : byte;              {  Hudson' }
   Name    : string;            {    PKT }
   Password: tPassword;         {  碮 㤠 }
  end;

  pConfig = ^tConfig;
  tConfig = record
   MainAddress    : t4D;
   SysOp          : string;
   RegKey         : string [48];
   FromAddress    : t4D;
   FromName       : tName;
   ToAddress      : t4D;
   ToName         : tName;
   Subject        : tSubj;
   Origin         : string [80];
   Area           : tArea;
   DefZone        : word;
   FileBoxes      : tPath;
   BSO            : tPath;
   LongFileBoxes  : string;
   LongBSO        : string;
   Packets        : string;
   AADateTime     : boolean;
   SkipBusyFlag   : boolean;
   EmptyPackAsPoll: boolean;
   LogFile        : tPath;
   LogState       : byte;
   LogFormat      : byte;
   Template       : tPath;
   Sorting        : byte;
  end;

 var
  CFG: pConfig;

 function  ReadConfigFile (Config: string; var Alias: string): byte;
 procedure DoneConfigFile;

implementation

 uses Default, StdFunc, MSG;

 function CheckReg: boolean;
 var N: System.LongInt;
     i: byte;
     R: array [0..1] of word absolute N;
     L: array [0..3] of byte absolute N;
     s: string;
     Name: string;
     RegNum: string;
     Addr: t4D;
 begin
  i:= 0;
  Addr:= CFG^.MainAddress;
  CheckReg:= False;
  if (CFG^.SysOp = '') or (CFG^.RegKey = '') then Exit;
  N:= 0;
  while i < Length (CFG^.SysOp) do begin
   inc (i);
   N:= i * $1418 + byte (CFG^.SysOp [i]) * $1481 + N;
  end;
  R [0]:= R [0] xor Addr [0];
  R [1]:= (R [1] + R [0]) xor Addr [0];
  R [0]:= (R [0] + R [1]) xor Addr [1] + R [1] xor (Addr [0] or Addr [1]);
  R [1]:= (R [1] + R [0]) and Addr [1] + R [1] xor Addr [1];
  R [0]:= R [1] xor Addr [2] + R [0];
  R [1]:= R [0] and Addr [2] + R [1] xor Addr [2];
  R [0]:= R [0] xor (R [1] or Addr [3]);
  R [1]:= R [1] or R [0] xor (Addr [2] or Addr [3]);
  RegNum:= '';
  for i:= 0 to 3 do begin
   case L [i] shr 4 of
   0..9: s:= char ($30 + l [i] shr 4);
   10..15: s:= char (55 + l [i] shr 4);
   end;
   case L [i] and 15 of
   0..9: s:= char ($30 + l [i] and 15)+s;
   10..15: s:= char (55 + l [i] and 15)+s;
   end;
   RegNum:= s + RegNum;
  end;
  if RegNum <> CFG^.RegKey then Exit;
  Writeln (#0#15'  ' + Registered_ + To_ + CFG^.SysOp + ' (' + ShowAddr (Addr) + ')  '#0#14 + Number_ + RegNum);
  CheckReg:= True;
 end;

 function CheckConfig: boolean;
 var Data: byte;
 begin
  CheckConfig:= False;
  if not CheckReg then Writeln (#0#12' '+Un_+Registered_+Version_);
  if CFG^.ToAddress [0] = 0 then
   for Data:= 0 to 2 do CFG^.ToAddress [Data]:= CFG^.FromAddress [Data];
  Data:= CheckNeedParametrs;
  if Data and $01 <> 0 then Writeln (Pref2_ + NoDefine + sFromAddress);
  if Data and $02 <> 0 then Writeln (Pref2_ + AlParamErr + sAreaPath);
  if Data and $04 <> 0 then Writeln (Pref2_ + NoDefine + sToAddress);
  if Data and $40 <> 0 then Writeln (Pref2_ + NoDefine + sDefZone);
  if Data and $80 <> 0 then Writeln (Pref2_ + NoDefine + sBSO);
  if Data <> 0 then Exit;
  CheckConfig:= True;
  SetPath;
 end;

 var
  CTLFile: text;
  Data: string;

 function LSCheck (Data: string; var ID: byte): boolean;
 begin
  LSCheck:= False;
  ID:= cAppend;
  if Data = sAppend then LSCheck:= True
  else if Data = sRewrite then begin
   LSCheck:= True;
   ID:= cRewrite;
  end else if Data = sConsole then begin
   LSCheck:= True;
   ID:= cConsole;
  end;
 end;

 function LFCheck (Data: string; var ID: byte): boolean;
 begin
  LFCheck:= False;
  ID:= cNormal;
  if Data = sNormal then LFCheck:= True
  else if Data = sDebug then begin
   ID:= cDebug;
   LFCheck:= True;
  end else if Data = sCrashDebug then begin
   LFCheck:= True;
   ID:= cCrashDebug;
  end else if Data = sAll then begin
   LFCheck:= True;
   ID:= cAll;
  end;
 end;

 function SortingCheck (Data: string; var ID: byte): boolean;
 begin
  SortingCheck:= False;
  ID:= cNode;
  if Data = sSize then begin
   SortingCheck:= True;
   ID:= cSize;
  end else if Data = sNode then SortingCheck:= True
  else if Data = sDays then begin
   SortingCheck:= True;
   ID:= cDays;
  end else if Data = sDaysSize then begin
   SortingCheck:= True;
   ID:= cDaysSize;
  end else if Data = sDaysNode then begin
   SortingCheck:= True;
   ID:= cDaysNode;
  end;
 end;

 function AreaAnalize (Data: string): boolean;
 var ParamStr: string;
     ParamID : byte;
     e: integer;
  function Param (Data: string; var Param_, NewData: string): boolean;
   var i: {$ifndef VER70}byte{$else}word{$endif};
   begin
    Param:= False;
    if (Data [1] = ';') or (Data = '') then Exit;
    NewData:= GetParam (Data);
    i:= 0;
    while Data [i + 1] <> ' ' do Inc (i);
    Param_:= Copy (Data, 1, i);
    Param:= True;
   end;
  function P_ID (Data: string; var ID: byte): boolean;
   begin
    P_ID:= False;
    ID:= $FF;
    if Data <> sPKT then
     if Data <> sNetMail then
      if Data <> sMSG then
       if Data <> sFile then Exit
       else ID:= cFile
      else ID:= cMSG
     else ID:= cNetMail
    else ID:= cPKT;
    P_ID:= True;
   end;
  function GetPath (Data: string; var Path, NewData: string): boolean;
   var i: {$ifdef VER70}byte{$else}word{$endif};
   begin
    GetPath:= False;
    if (Data = '') or (Data [1] = ';') then Exit;
    if Data [1] = '"' then begin
     i:= 0;
     while (Data [i + 2] <> '"') and (i + 1 < Length (Data)) do Inc (i);
     if Data [i + 1] <> '"' then Exit;
     Path:= Copy (Data, 2, i);
     Inc (i);
    end else begin
     i:= 0;
     while (Data [i + 1] <> ' ') and (i < Length (Data)) do Inc (i);
     Path:= Copy (Data, 1, i);
    end;
    if Data = Path then NewData:= ''
                   else NewData:= DelFirstSpace (Copy (Data, i + 1, Length (Data) - i));
    if Path [Length (Path)] = '\' then Path:= Copy (Path, 1, Length (Path) - 1);
    GetPath:= True;
   end;
  function GetAP (Data: string; var Echo: string; var Password: tPassword): boolean;
   var i: word;
   begin
    GetAP:= False;
    if (Data = '') or (Data [1] = ';') then Exit;
    i:= 0;
    while (Data [i + 1] <> ' ') and (i < Length (Data)) do Inc (i);
    Echo:= UpStr (Copy (Data, 1, i));
    Password:= UpStr (GetParam (Data));
    GetAP:= True;
   end;
  begin
  CFG^.Area.Password:= '';
  AreaAnalize:= False;
  Param (Data, ParamStr, Data);
  ParamStr:= UpStr (ParamStr);
  if not P_ID (ParamStr, ParamID) then Exit;
  CFG^.Area.MSGType:= ParamID - cPKT + 1;
  if not GetPath (Data, CFG^.Area.Path, Data) then Exit;
  if (CFG^.Area.MSGType = 1) and not GetAP (Data, CFG^.Area.Name, CFG^.Area.Password) then Exit;
  AreaAnalize:= True;
 end;

 function SkipBusyFlagState (Data: string): boolean;
 var D: string;
 begin
  SkipBusyFlagState:= False;
  if Data <> sYes then
   if Data <> sNo then Exit
   else CFG^.SkipBusyFlag:= False
  else CFG^.SkipBusyFlag:= True;
  SkipBusyFlagState:= True;
 end;

 function EmptyPackAsPollState (Data: string): boolean;
 var D: string;
 begin
  EmptyPackAsPollState:= False;
  if Data <> sYes then
   if Data <> sNo then Exit
   else CFG^.EmptyPackAsPoll:= False
  else CFG^.EmptyPackAsPoll:= True;
  EmptyPackAsPollState:= True;
 end;

 function AADateTimeState (Data: string): boolean;
 var D: string;
 begin
  AADateTimeState:= False;
  if Data <> sYes then
   if Data <> sNo then Exit
   else CFG^.AADateTime:= False
  else CFG^.AADateTime:= True;
  AADateTimeState:= True;
 end;

 function ReadConfigFile (Config: string; var Alias: string): byte;
 var State : byte;
     StrNum: word;
     Err: longint;
 begin
  Alias:= '';
  Assign (CTLFile, Config);
  Reset (CTLFile);
  StrNum:= IOResult;
  if StrNum <> 0 then begin
   ReadConfigFile:= esCtlNFound;
   Exit;
  end;
{$ifndef WIN32}
  if not CheckMemory (MemAvail, SizeOf (tConfig)) then begin
   ReadConfigFile:= esNoMemory;
   Exit;
  end else
{$endif}
  New (CFG);
  SetDefaultParametrs;
  StrNum:= 0;
  while not Eof (CTLFile) do begin
   Readln (CTLFile, Data);
   if IOResult <> 0 then begin
    ReadConfigFile:= esCtlRead;
    Exit;
   end;
   Inc (StrNum);
   Data:= DelComment (DelFirstSpace (ConvertTabs (Data)));
   case GetAliasID (Data) of
    cFromAddress     : if not GetAddress (Data, CFG^.FromAddress) then begin
                        ReadConfigFile:= esAlParamAddr;
                        Alias:= sFromAddress;
                        Close (CTLFile);
                        Exit;
                       end;
    cFromName        : CFG^.FromName:= GetParam (Data);
    cToAddress       : if not GetAddress (Data, CFG^.ToAddress) then begin
                        ReadConfigFile:= esAlParamAddr;
                        Alias:= sToAddress;
                        Close (CTLFile);
                        Exit;
                       end;
    cToName          : CFG^.ToName:= GetParam (Data);
    cSubject         : CFG^.Subject:= GetParam (Data);
    cAreaPath        : if not AreaAnalize (GetParam (Data)) then begin
                        ReadConfigFile:= esAlParamArea;
                        Alias:= sAreaPath;
                        Close (CTLFile);
                        Exit;
                       end;
    cDefZone         : Val (GetParam (Data), CFG^.DefZone, Err);
    cFileBoxes       : begin
                        Data:= GetParam (Data);
                        if Data [Length (Data)] <> '\' then Data:= Data + '\';
                        CFG^.FileBoxes:= Data;
                       end;
    cLongFileBoxes   : begin
                        Data:= GetParam (Data);
                        if Data [Length (Data)] <> '\' then Data:= Data + '\';
                        CFG^.LongFileBoxes:= Data;
                       end;
    cBSO             : begin
                        Data:= GetParam (Data);
                        if Data [Length (Data)] <> '\' then Data:= Data + '\';
                        CFG^.BSO:= Data;
                       end;
    cLongBSO         : begin
                        Data:= GetParam (Data);
                        if Data [Length (Data)] <> '\' then Data:= Data + '\';
                        CFG^.LongBSO:= Data
                       end;
    cLogFile         : CFG^.LogFile:= GetParam (Data);
    cLogState        : if not LSCheck (UpStr (GetParam (Data)), CFG^.LogState) then
                        Writeln (Pref2_ + AlParamErr + sLogState);
    cLogFormat       : if not LFCheck (UpStr (GetParam (Data)), CFG^.LogFormat) then
                        Writeln (Pref2_ + AlParamErr + sLogFormat);
    cTemplate        : CFG^.Template:= GetParam (Data);
    cSorting         : if not SortingCheck (UpStr (GetParam (Data)), CFG^.Sorting) then
                        Writeln (Pref2_ + AlParamErr + sSorting);
    cSkipBusyFlag    : if not SkipBusyFlagState (UpStr (GetParam (Data))) then
                        Writeln (Pref2_ + AlParamErr + sSkipBusyFlag);
    cEmptyPackAsPoll : if not EmptyPackAsPollState (UpStr (GetParam (Data))) then
                        Writeln (Pref2_ + AlParamErr + sEmptyPackAsPoll);
    cAADateTime      : if not AADateTimeState (UpStr (GetParam (Data))) then
                        Writeln (Pref2_ + AlParamErr + sAADateTime);
    cOrigin          : CFG^.Origin:= GetParam (Data);
    cMainAddress     : if not GetAddress (Data, CFG^.MainAddress) then begin
                        ReadConfigFile:= esAlParamAddr;
                        Alias:= sMainAddress;
                        Close (CTLFile);
                        Exit;
                       end;
    cSysOp           : CFG^.SysOp:= GetParam (Data);
    cRegKey          : CFG^.RegKey:= UpStr (GetParam (Data));
    cTMail_Packets   : begin
                        Data:= GetParam (Data);
                        if Data [Length (Data)] <> '\' then Data:= Data + '\';
                        CFG^.Packets:= Data
                       end;
    $FF              : WriteErrStr (StrNum, Data);
   end;
  end;
  Close (CTLFile);
  ReadConfigFile:= esAlParamCor;
  if CheckConfig then ReadConfigFile:= esNoErr;
 end;

 procedure DoneConfigFile;
 begin
  if CFG <> nil then Dispose (CFG);
 end;

end.
