unit Default;

interface

{$ifdef Win32}
{$H+}
{$endif}

 uses Log, Aliases, FileNms, Types, Messages, StdFunc
{$ifndef Win32}
  , Use32, Dos
{$else}
  , WIndows
{$endif};

 procedure SetDefaultParametrs;
 function CheckNeedParametrs: byte;
 procedure SetPath;

implementation

 uses Config;

 const
  DefAddr: t4D = (0, 0, 0, 0);

 procedure SetDefaultParametrs;
 begin
  with CFG^ do begin
   FromAddress:= DefAddr;
   FromName:= PrgName;
   ToAddress:= DefAddr;
   ToName:= 'All';
   Subject:= 'Queue report';
   Origin:= '';
   Area.MSGType:= 0;
   Area.Path:= '';
   Area.ID:= 0;
   Area.Name:= '';
   Area.Password:= '';
   DefZone:= 0;
   FileBoxes:= '';
   BSO:= '';
   LongFileBoxes:= '';
   LongBSO:= '';
   Packets:= '';
//   Revision:= 0;
   AADateTime:= True;
   SkipBusyFlag:= False;
   EmptyPackAsPoll:= False;
   LogFile:= PrgFile + LogExt;
   LogState:= cAppend;
   LogFormat:= cNormal;
   Template:= PrgFile + TplExt;
   Sorting:= cNode;
  end;
 end;

 function CheckNeedParametrs: byte;
 var Temp: word;
 begin
  Temp:= 0;
  with CFG^ do begin
   if (Area.MSGType <> 7) and (FromAddress [0] = 0) then Temp:= Temp or $01;
   if (Area.MSGType < 1) or (Area.MSGType > 7) then Temp:= Temp or $02;
   if ((Area.MSGType = 4) or (Area.Name = sNetMail)) and (ToAddress [0] = 0) then Temp:= Temp or $04;
   if Area.Path = '' then Temp:= Temp or $01;
   if (Area.MSGType = 1) and (Area.Name = '') then Temp:= Temp or $01;
   if DefZone < 1 then Temp:= Temp or $40;
   if BSO = '' then Temp:= Temp or $80;
  end;
  CheckNeedParametrs:= Temp;
 end;

 procedure SetPath;
  function Scan (Data: string): string;
  var i: word;
      Param, New1, New2: string;
 {$ifdef Win32}
      Env: array [0..32767] of char;
 {$endif}
  begin
   Scan:= '';
   if Data = '' then Exit;
   i:= 1;
   Param:= '';
   New2:= '';
   while (Data [i] <> '%') and (i < Length (Data)) do Inc (i);
   if not (i > Length (Data) - 2) then begin
    Param:= Copy (Data, i + 1, Length (Data) - i);
    i:= 1;
    while (Param [i] <> '%') and (i < Length (Param)) do Inc (i);
    New2:= Copy (Param, i + 1, Length (Param) - i);
    Param:= Copy (Param, 1, i - 1);
 {$ifdef Win32}
    Param:= Param + #0;
    for i:= 0 to 32767 do Env [i] := #0;
    GetEnvironmentVariable (@Param [1], @Env, 32768);
    i:= 0;
    Param:= '';
    while Env [i] <> #0 do begin
     Param:= Param + Env [i];
     Inc (i);
    end;
 {$else}
    Param:= GetEnv (Param);
 {$endif}
   end else New2:= Data;
   if Param = '' then New1:= Data else New1:= Param + New2;
   if New1 [1] <> '\' then if (New1 [2] <> ':') then New1:= ProgramPath + New1;
   Scan:= New1;
  end;
 begin
  with CFG^ do begin
   Area.Path:= Scan (Area.Path);
   FileBoxes:= Scan (FileBoxes);
   BSO:= Scan (BSO);
   LongFileBoxes:= Scan (LongFileBoxes);
   LongBSO:= Scan (LongBSO);
   LogFile:= Scan (LogFile);
   Packets:= Scan (Packets);
   Template:= Scan (Template);
  end;
 end;

end.
