unit Init;

interface

{$ifdef Win32}
{$H+}
{$endif}

 uses Config, StdFunc, Filenms, Errors, Messages, Log, WriteF
{$ifndef WIN32}
  , Use32
{$else}
  , SysUtils
{$endif};

 procedure InitAllModules;
 procedure DoneAllModules;

implementation

 uses Queue

{$ifdef Win32}
 , Types;

 procedure InitMonth;
 var t: byte;
 begin
  for t:= 1 to 12 do ShortMonthNames [t]:= Month [t];
  for t:= 1 to 7 do LongDayNames [t]:= Days [t];
 end;
{$else} ;
{$endif}

 procedure InitAllModules;
 var State: byte;
     Al: string;
 begin
  State:= ReadConfigFile (ProgramPath + PrgFile + CTLExt, Al);
  if (State <> esNoErr) and (State <> esAlParam) then DoneConfigFile;
  case State of
{$ifndef Win32}
   esNoMemory	: ErrHalt (State, NoMem);
{$endif}

   esCtlNFound	: ErrHalt (State, Cant + Found_ + CtlFile + PrgFile + CTLExt);
   esCtlRead	: ErrHalt (State, Cant + CtlReadErr + CtlFile + PrgFile + CTLExt);

   esAlParamAddr: ErrHalt (State, AlParamErr + Al);
   esAlParamArea: ErrHalt (State, AlParamErr + Al);
   esAlParamCor : ErrHalt (State, '');
  end;

  State:= InitLogFile (CFG^.LogFile);
  case State of
   12: Writeln (Pref2_ + Cant + LogCreateErr + LogFile);
   13: Writeln (Pref2_ + Cant + LogWriteErr + LogFile);
  end;
  if State <> 0 then Writeln (Pref2_ + LogDesabled);
  InitQueue;
{$ifdef Win32}
  InitMonth;
{$endif}
 end;

 procedure DoneAllModules;
 begin
  DoneQueue;
  DoneConfigFile;
  DoneLogFile;
 end;

end.
