unit Log;

interface

{$ifdef Win32}
{$H+}
{$endif}

 uses Messages, Errors, Config, Aliases, WriteF,
{$ifndef Win32}
  Use32
{$else}
  Windows
{$endif};

 function InitLogFile (LogFileName: string): byte;
 procedure ToLog (Level: byte; Str: string);
 procedure DoneLogFile;

implementation

 uses StdFunc;

 var LogFileLink: {$ifndef Win32}Text{$else}TextFile{$endif};
     UseLog: boolean;
     MLevel: byte;
     MState: boolean;

 function InitLogFile (LogFileName: string): byte;
 var i: byte;
     LS: boolean;
  function NewLog: boolean;
  begin
   NewLog:= True;
   Rewrite (LogFileLink);
   if IOResult <> 0 then NewLog:= False;
  end;
 begin
  InitLogFile:= esNoErr;
  Assign (LogFileLink, LogFileName);
  UseLog:= True;
  MLevel:= CFG^.LogFormat - 50;
  if CFG^.LogState = cConsole then MState:= True
  else begin
   MState:= False;
   if CFG^.LogState = cRewrite then LS:= NewLog
   else begin
    Append (LogFileLink);
    LS:= True;
    if IOResult <> 0 then LS:= NewLog;
   end;
   if not LS then begin
    InitLogFile:= esLogCreate;
    UseLog:= False;
    Exit;
   end;
  end;
  if MState then begin
   Writeln (#0#14+Date+' '+Time+PrgName+PrgVer+PrgBits);
   for i:= 1 to 77 do Write (#0#14'');
   Writeln ('');
   InitLogFile:= esNoErr;
  end else begin
   System.Writeln (LogFileLink);
   if IOResult <> 0 then begin
    Close (LogFileLink);
    InitLogFile:= esLogWrite;
    UseLog:= False;
    Exit;
   end;
   System.Writeln (LogFileLink, Date, ' ', Time, PrgName, PrgVer, PrgBits);
   if IOResult <> 0 then begin
    Close (LogFileLink);
    InitLogFile:= esLogWrite;
    UseLog:= False;
    Exit;
   end;
   for i:= 1 to 77 do begin
    System.Write (LogFileLink, '');
    if IOResult <> 0 then begin
     Close (LogFileLink);
     InitLogFile:= esLogWrite;
     UseLog:= False;
     Exit;
    end;
   end;
   System.Writeln (LogFileLink);
   if IOResult <> 0 then begin
    Close (LogFileLink);
    InitLogFile:= esLogWrite;
    UseLog:= False;
    Exit;
   end;
   Flush (LogFileLink);
  end;
 end;

 procedure ToLog (Level: byte; Str: string);
 begin
  if not UseLog then Exit;
  if Level <= MLevel then
   if MState then Writeln (#0#13+Time+' '#0#15+Str)
   else begin
    System.Writeln (LogFileLink, Time, ' ', Str);
    if IOResult <> 0 then begin
     Close (LogFileLink);
     UseLog:= False;
     Exit;
    end;
    Flush (LogFileLink);
   end;
 end;

 procedure DoneLogFile;
 var i: byte;
 begin
  if not UseLog then Exit;
  if not MState then begin
   for i:= 1 to 77 do begin
    System.Write (LogFileLink, '');
    if IOResult <> 0 then begin
     Close (LogFileLink);
     UseLog:= False;
     Exit;
    end;
   end;
   System.Writeln (LogFileLink);
   System.Writeln (LogFileLink);
   if IOResult <> 0 then begin
    Close (LogFileLink);
    UseLog:= False;
    Exit;
   end;
   Close (LogFileLink);
  end else begin
   for i:= 1 to 77 do Write (#0#14'');
   Writeln ('');
  end;
 end;

end.

