unit Queue;

interface

 uses Types, Log, Init, StdFunc, Messages, SysUtils
{$ifndef Win32}
  , Errors
{$endif};

 const
  tmNetmail: byte = 0;
  tmArcMail: byte = 1;
  tmFiles  : byte = 2;
  tmTic    : byte = 3;
  tmRequest: byte = 4;

 var
  Q  : pQueue;
  QCR: word;

 procedure InitQueue;
 procedure DoneQueue;

 procedure AddMailSize (Addr: t4D; tm: byte; Size: Longint);
 procedure AddMail (Addr: t4D; tm: byte; Size, Time: LongInt; Flag: string);
 procedure AddFlag (Addr: t4D; Flag: string);
 procedure AddTime (Addr: t4D; Time: Longint; Flag: string);

implementation

 const
  SetQueueDate: string [14] = #16' Set new date';
  SetAddFlag  : string [23] = #16' Set additional flag ';
  For__       : string [5]  = ' for ';

 procedure InitQueue;
 begin
//  ToLog (3, ExecFunc_ + 'Queue.InitQueue ()');
  Q:= nil;
  QCR:= 0;
//  ToLog (3, EndFunc_ + 'Queue.InitQueue');
 end;

 procedure DoneQueue;
 begin
//   ToLog (3, ExecFunc_ + 'Queue.DoneQueue ()');
  if Q = nil then begin
//   ToLog (3, EndFunc_ + 'Queue.DoneQueue');
   Exit;
  end;
  while Q^.Prev <> nil do Q:= Q^.Prev;
  while Q^.Next <> nil do begin
   Q:= Q^.Next;
   Dispose (Q^.Prev);
  end;
  Dispose (Q);
//  ToLog (3, EndFunc_ + 'Queue.DoneQueue');
 end;

 procedure SetDate (Date_: LongInt);
 var Day, Month, Year: word;
     Hour, Min, Sec, MSec: word;
  procedure SetTime;
  begin
//   ToLog (3, ExecFunc_ + 'Queue.SetDate.SetTime ()');
   with Q^.Time do begin
    H:= Hour;
    M:= Min;
    S:= Sec;
   end;
   ToLog (2, SetQueueDate + For__ + ShowAddr (Q^.Addr) + ' => ' + GetDateTime (Year, Month, Day, Hour, Min, Sec));
//   ToLog (3, EndFunc_ + 'Queue.SetDate.SetTime');
  end;
  procedure UpDateTime;
  begin
//   ToLog (3, ExecFunc_ + 'Queue.SetDate.UpDateTime ()');
   with Q^.Time do
    if H > Hour then SetTime
    else if H = Hour then if M > Min then SetTime
    else if M = Min then if S> Sec then SetTime;
//   ToLog (3, EndFunc_ + 'Queue.SetDate.UpDateTime');
  end;
  procedure SetDate;
  begin
//   ToLog (3, ExecFunc_ + 'Queue.SetDate.SetDate ()');
   with Q^ do begin
    Date.Y:= Year;
    Date.M:= Month;
    Date.D:= Day;
    Time.H:= Hour;
    Time.M:= Min;
    Time.S:= Sec;
   end;
   ToLog (2, SetQueueDate + For__ + ShowAddr (Q^.Addr) + ' => ' + GetDateTime (Year, Month, Day, Hour, Min, Sec));
//   ToLog (3, EndFunc_ + 'Queue.SetDate.SetDate');
  end;
  procedure CompareDate;
  begin
//   ToLog (3, ExecFunc_ + 'Queue.SetDate.CompareDate ()');
    with Q^.Date do
     if Y > Year then SetDate
     else if Y = Year then if M > Month then SetDate
     else if M = Month then if D > Day then SetDate
     else if D = Day then UpdateTime;
//   ToLog (3, EndFunc_ + 'Queue.SetDate.CompareDate');
  end;
 begin
//  ToLog (3, ExecFunc_ + 'Queue.SetDate ()');
  DecodeDate (FileDateToDateTime (Date_), Year, Month, Day);
  DecodeTime (FileDateToDateTime (Date_), Hour, Min, Sec, MSec);
  CompareDate;
//  ToLog (3, EndFunc_ + 'Queue.SetDate');
 end;

 procedure SetFlag (Flag: string);
 begin
//  ToLog (3, ExecFunc_ + 'Queue.SetFlag ()');
  case Flag [1] of
   'b': Q^.Flag [1]:= 'b';
   'C': Q^.Flag [3]:= 'C';
   'I': Q^.Flag [4]:= 'I';
   'D': Q^.Flag [5]:= 'D';
   'N', 'F', 'O': Q^.Flag [6]:= 'N';
   'H': Q^.Flag [7]:= 'H';
   'R': Q^.Flag [8]:= 'R';
  end;
  ToLog (2, SetAddFlag + Flag [1] + For__ + ShowAddr (Q^.Addr));
//  ToLog (3, EndFunc_ + 'Queue.SetFlag');
 end;

 procedure AddAddr (Addr: t4D);
  procedure SetCDate;
  var D, M, Y, W: word;
  begin
//   ToLog (3, ExecFunc_ + 'Queue.AddAddr.SetCDate ()');
   DecodeDate (Date, Y, M, D);
   Q^.Date.D:= D;
   Q^.Date.M:= M;
   Q^.Date.Y:= Y;
   DecodeTime (Time, Y, M, D, W);
   Q^.Time.H:= Y;
   Q^.Time.M:= M;
   Q^.Time.S:= D;
//   ToLog (3, EndFunc_ + 'Queue.AddAddr.SetCDate');
  end;
 begin
//  ToLog (3, ExecFunc_ + 'Queue.AddAddr ()');
{$ifndef Win32}
  if not CheckMemory (MemAvail, SizeOf (tQueue)) then begin
   ToLog (0, NoMem);
   ToLog (0, InModule_ + Module1);
   DoneAllModules;
   ErrHalt (esNoMemory, '');
  end;
{$endif}
  if Q = nil then begin
   Q:= New (pQueue);
   Q^.Prev:= nil;
  end else begin
   Q^.Next:= New (pQueue);
   Q^.Next^.Prev:= Q;
   Q:= Q^.Next;
  end;
  Q^.Next:= nil;
  Q^.Addr:= Addr;
  SetCDate;
  Q^.NM:= 0;
  Q^.AM:= 0;
  Q^.FM:= 0;
  Q^.NF:= 0;
  Q^.AF:= 0;
  Q^.FF:= 0;
  Q^.Flag:= '        ';
  Inc (QCR);
//  ToLog (3, EndFunc_ + 'Queue.AddAddr');
 end;

 procedure FindAddr (Addr: t4D);
 var i: byte;
  procedure StartFind;
  begin
//   ToLog (3, ExecFunc_ + 'Queue.FindAddr.StartFind ()');
   while Q^.Prev <> nil do Q:= Q^.Prev;
   while Q^.Next <> nil do begin
    if (Addr [0] = Q^.Addr [0]) and
       (Addr [1] = Q^.Addr [1]) and
       (Addr [2] = Q^.Addr [2]) and
       (Addr [3] = Q^.Addr [3]) then begin
//     ToLog (3, EndFunc_ + 'Queue.FindAddr.StartFind');
     Exit;
    end;
    Q:= Q^.Next;
   end;
   if (Addr [0] = Q^.Addr [0]) and
      (Addr [1] = Q^.Addr [1]) and
      (Addr [2] = Q^.Addr [2]) and
      (Addr [3] = Q^.Addr [3]) then
                               else AddAddr (Addr);
//   ToLog (3, EndFunc_ + 'Queue.FindAddr.StartFind');
  end;
 begin
//  ToLog (3, ExecFunc_ + 'Queue.FindAddr ()');
  for i:= 0 to 3 do if Addr [i] <> Q^.Addr [i] then begin
   StartFind;
//   ToLog (3, EndFunc_ + 'Queue.FindAddr');
   Exit;
  end;
//  ToLog (3, EndFunc_ + 'Queue.FindAddr');
 end;

 procedure AddMailSize (Addr: t4D; tm: byte; Size: Longint);
 begin
//  ToLog (3, ExecFunc_ + 'Queue.AddMailSize ()');
  if Q <> nil then FindAddr (Addr)
              else AddAddr (Addr);
  case tm of
   0      : Q^.NM:= Q^.NM + Size;
   1      : Q^.AM:= Q^.AM + Size;
   2, 3, 4: Q^.FM:= Q^.FM + Size;
  end;
//  ToLog (3, EndFunc_ + 'Queue.AddMailSize');
 end;

 procedure AddMail (Addr: t4D; tm: byte; Size, Time: LongInt; Flag: string);
 var
  Info: string;
 begin
//  ToLog (3, ExecFunc_ + 'Queue.AddMail ()');
  AddMailSize (Addr, tm, Size);
  case tm of
   0      : Inc (Q^.NF);
   1      : Inc (Q^.AF);
   2, 3, 4: Inc (Q^.FF);
  end;
  Info:= For_ + ShowAddr (Addr) + NetMail_ + DWordToStr (Q^.NF) +
                                  ArcMail_ + DWordToStr (Q^.AF) +
                                  FMail_ + DWordToStr (Q^.FF);
  ToLog (2, Info);
  if tm <> 2 then SetDate (Time);
  SetFlag (Flag);
//  ToLog (3, EndFunc_ + 'Queue.AddMail');
 end;

 procedure AddFlag (Addr: t4D; Flag: string);
 begin
//  ToLog (3, ExecFunc_ + 'Queue.AddFlag ()');
  if Q <> nil then FindAddr (Addr)
              else AddAddr (Addr);
  SetFlag (Flag);
//  ToLog (3, EndFunc_ + 'Queue.AddFlag');
 end;

 procedure AddTime (Addr: t4D; Time: longint; Flag: string);
 begin
//  ToLog (3, ExecFunc_ + 'Queue.AddTime ()');
  AddFlag (Addr, Flag);
  SetDate (Time);
//  ToLog (3, EndFunc_ + 'Queue.AddTime');
 end;

end.
