unit Scanner;

interface

 uses Log, Queue, Types, Config, Messages, StdFunc, FileNms, SysUtils
{$ifndef Win32}
  , Use32
{$endif};

 procedure ScanBoxes;

implementation

 var
  Level0, Level1, Level2: pDirList;
  Addr, Addr2           : t4D;
  e                     : integer;
  AL                    : byte;
  F                     : boolean;
  Flag                  : string;

 procedure Analyze (Rec: TSearchRec; Path: string); forward;

 procedure Analyze2 (Path: string);
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.Analyze2 ()');
  ToLog (1, Analyze_ + Path);
  ScanDir (Path, mAllName, $2F, Level2);
  if Level2 = nil then begin
//   ToLog (3, EndFunc_ + 'Scanner.Analyze2');
   Exit;
  end;
  Al:= 2;
  while Level2^.Next <> nil do begin
   Analyze (Level2^.Name, Path);
   Level2:= Level2^.Next;
  end;
  Analyze (Level2^.Name, Path);
  KillDir (Level2);
  AL:= 1;
//  ToLog (3, EndFunc_ + 'Scanner.Analyze2');
 end;

 procedure Analyze1 (Path: string);
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.Analyze1 ()');
  ToLog (1, Analyze_ + Path);
  ScanDir (Path, mAllName, $3F, Level1);
  if Level1 = nil then Exit;
  AL:= 1;
  while Level1^.Next <> nil do begin
   Analyze (Level1^.Name, Path);
   Level1:= Level1^.Next;
  end;
  Analyze (Level1^.Name, Path);
  KillDir (Level1);
  AL:= 0;
//  ToLog (3, EndFunc_ + 'Scanner.Analyze1');
 end;

 function GetFlag (Data: string; var ND, Flag: string): boolean;
 var D: string;
     G: boolean;
     Z: string;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.GetFlag ()');
  G:= False;
  Flag:= '';
  D:= GetMExt (Data, ND);
  if (D = '') or (Length (D) < 3) then Exit;
  if (D = fHold) or
     (D = fNormal) or
     (D = fDirect) or
     (D = fCrash) or
     (D = fImmediate) or
     (D = fBusy) or
     (D = fRequest) or
     (D = fREQ) or
     (D = fBSY) or
     (Copy (D, 2, 2) = eUT) or
     (Copy (D, 2, 2) = eLO) then G:= True;
  if G then Flag:= D [1];
  GetFlag:= G;
//  ToLog (3, EndFunc_ + 'Scanner.GetFlag');
 end;

 function GetAddr (Data: string; TA: byte): boolean;
 var ND, D: string;
     i: byte;
     j: byte;
     es: string;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.GetAddr ()');
  GetAddr:= False;
  Str (TA, es);
  ToLog (1, Analyze_ + es + ' ' + Data);
  case TA of
   0: begin
       ND:= Data;
       ToLog (1, ND);
       for i:= 1 to 4 do begin
        D:= GetMExt (ND, ND);
        if D = '' then Exit;
        Val (D, Addr [4 - i], e);
       end;
       for i:= 0 to 3 do begin
        case i of
         0: es:= '';
         1: es:= es + ':';
         2: es:= es + '/';
         3: es:= es + '.';
        end;
        Str (Addr [i], D);
        es:= es + D;
       end;
       ToLog (2, Decode_ + es);
       GetAddr:= True;
      end;
   1: begin              { Node address }
       DError:= False;
       GetAddr:= False;
       Addr [0]:= Addr2 [0];
       Addr [1]:= 0;
       Addr [2]:= 0;
       Addr [3]:= 0;
       for i:= 1 to 8 do begin
        case i of
         4, 8: Addr [1+Trunc (i/5)]:= Addr [1+Trunc (i/5)] + c16to10 (Data [i]);
         3, 7: Addr [1+Trunc (i/5)]:= Addr [1+Trunc (i/5)] + 16   * c16to10 (Data [i]);
         2, 6: Addr [1+Trunc (i/5)]:= Addr [1+Trunc (i/5)] + 256  * c16to10 (Data [i]);
         1, 5: Addr [1+Trunc (i/5)]:= Addr [1+Trunc (i/5)] + 4096 * c16to10 (Data [i]);
        end;
        if DError then Exit;
       end;
       Addr2:= Addr;
       for i:= 0 to 3 do begin
        case i of
         0: es:= '';
         1: es:= es + ':';
         2: es:= es + '/';
         3: es:= es + '.';
        end;
        Str (Addr [i], D);
        es:= es + D;
       end;
       ToLog (2, Decode_ + es);
       GetAddr:= True;
      end;
   2: begin              { Point address }
       DError:= False;
       GetAddr:= False;
       Addr:= Addr2;
       for i:= 1 to 8 do begin
        e:= 1;
        for j:= 1 to 8 - i do e:= e * 16;
        Addr [3]:= Addr [3] + e * c16to10 (Data [i]);
        if DError then Exit;
       end;
       for i:= 0 to 3 do begin
        case i of
         0: es:= '';
         1: es:= es + ':';
         2: es:= es + '/';
         3: es:= es + '.';
        end;
        Str (Addr [i], D);
        es:= es + D;
       end;
       ToLog (2, Decode_ + es);
       GetAddr:= True;
      end;
   3: begin              { Address of fileboxe }
       DError:= False;
       ClearAddr (Addr);
       D:= GetMExt (Data, ND);
       for i:= 1 to 8 do
        case i of
         3, 6   : Addr [Trunc (i/3)]:= Addr [Trunc (i/3)] + c32to10 (ND [i]) * 1024;
         1, 4, 7: Addr [Trunc (i/3)]:= Addr [Trunc (i/3)] + c32to10 (ND [i]) * 32;
         2, 5, 8: Addr [Trunc (i/3)]:= Addr [Trunc (i/3)] + c32to10 (ND [i]);
        end;
       Addr [3]:= c32to10 (D [1]) * 32 + c32to10 (D [2]);
       for i:= 0 to 3 do begin
        case i of
         0: es:= '';
         1: es:= es + ':';
         2: es:= es + '/';
         3: es:= es + '.';
        end;
        Str (Addr [i], D);
        es:= es + D;
       end;
       ToLog (2, Decode_ + es);
       GetAddr:= not DError;
      end;
   4: begin
       ND:= Data;
       ToLog (0, ND);
       for i:= 1 to 3 do begin
        D:= GetMExt (ND, ND);
        if D = '' then Exit;
        Val (D, Addr [4 - i], e);
       end;
       Val (ND, Addr [0], e);
       for i:= 0 to 3 do begin
        case i of
         0: es:= '';
         1: es:= es + ':';
         2: es:= es + '/';
         3: es:= es + '.';
        end;
        Str (Addr [i], D);
        es:= es + D;
       end;
       ToLog (2, Decode_ + es);
       GetAddr:= True;
      end;
  end;
//  ToLog (3, EndFunc_ + 'Scanner.GetAddr');
 end;

 function WhatIsIt (CheckAddr: boolean; E: string; var Flag: string): byte;
 var ND, D: string;
     i    : byte;
     a    : word;
     er   : integer;
     es   : string;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.WhatIsIt ()');
  WhatIsIt:= 0;
  D:= UpStr (GetMExt (E, ND));
  if (D = eState) or (D = eSTA) then begin
   WhatIsIt:= $E0;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if D = eTIC then begin
   WhatIsIt:= $0E;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  for i:= 0 to 6 do if Copy (D, 1, 2) = eDM [i] then begin
   WhatIsIt:= $0D;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if f and (D = ePKT) then begin
   WhatIsIt:= $06;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if F or CheckAddr then Exit;
  if D = eMail then begin
   WhatIsIt:= $FF;
   if not GetFlag (ND, ND, Flag) then Exit;
   if not GetAddr (ND, 0) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $01;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if D = eList then begin
   WhatIsIt:= $FF;
   if not GetFlag (ND, ND, Flag) then Exit;
   if not GetAddr (ND, 0) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $02;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if D = fBusy then begin
   Flag:= 'b';
   WhatIsIt:= $FF;
   if not GetAddr (ND, 0) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $03;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if (D = fHold) or
     (D = fNormal) or
     (D = fDirect) or
     (D = fCrash) or
     (D = fImmediate) then begin
   Flag:= D [1];
   WhatIsIt:= $FF;
   if not GetAddr (ND, 0) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $04;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if D = fRequest then begin
   Flag:= 'R';
   WhatIsIt:= $FF;
   if not GetAddr (ND, 0) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $05;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if (Copy (D, 2, 2) = eUT) and (D [1] in ['R', 'C', 'I', 'D', 'O', 'H']) then begin
   Flag:= D [1];
   WhatIsIt:= $FF;
   if not GetAddr (ND, AL) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $06;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if (Copy (D, 2, 2) = eLO) and (D [1] in ['R', 'C', 'I', 'D', 'F', 'H']) then begin
   Flag:= D [1];
   WhatIsIt:= $FF;
   if not GetAddr (ND, AL) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $07;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if D = fBSY then begin
   Flag:= 'b';
   WhatIsIt:= $FF;
   if not GetAddr (ND, AL) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $08;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if D = fREQ then begin
   Flag:= 'R';
   WhatIsIt:= $FF;
   if not GetAddr (ND, AL) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $09;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if (D = ePNT) and (Length (ND) = 8) then begin
   Flag:= '';
   WhatIsIt:= $FF;
   if not GetAddr (ND, 1) then begin
    ToLog (2, Decode_ + Failure_);
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
   WhatIsIt:= $0A;
//   ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
   Exit;
  end;
  if ((Length (E) = 12) and ((D [3] = 'I') or
      (D [3] = 'C') or (D [3] = 'D') or (D [3] = 'H'))) or
     ((Length (E) = 11) and (E [9] = '.')) then
   if GetAddr (E, 3) then begin
    Flag:= '';
    if Length (E) = 12 then if (E [12] = 'I') or
                               (E [12] = 'C') or
                               (E [12] = 'D') or
                               (E [12] = 'H') then Flag:= E [12]
    else else Flag:= 'N';
    if Flag <> '' then WhatIsIt:= $0B;
//    ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
    Exit;
   end;
  if D = 'H' then if GetAddr (ND, 4) then begin
   WhatIsIt:= $0C;
   Flag:= D;
  end else else begin
   Val (D, a, er);
   Str (a, es);
   if D <> es then Exit;
   if GetAddr (E, 4) then begin
    WhatIsIt:= $0C;
    Flag:= 'N';
   end;
  end;
//  ToLog (3, EndFunc_ + 'Scanner.WhatIsIt');
 end;

 procedure ScanLO (Path, Flag: string);
 var F  : {$ifdef Win32}textfile{$else}text{$endif};
     F2 : integer;
     Rec: TSearchRec;
     es : string;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.ScanLO ()');
  Assign (F, Path);
  Reset (F);
  if IOResult <> 0 then Exit;
  ToLog (1, Analyze_ + Path);
  while not EOF (F) do begin
   Readln (F, es);
   if DelFirstSpace (es) <> '' then begin
    if (es [1] = '#') or
       (es [1] = '~') or
       (es [1] = '^') then es:= Copy (es, 2, Length (es) - 1);
    if (es [1] <> '\') and (es [2] <> ':') and (es [1] <> ':') then es:= ExtractFileDir (Path) + '\' + es;
    ToLog (1, Analyze_ + es);
    F2:= FindFirst (es, $3F, Rec);
    if F2 = 0 then begin
     ToLog (1, Analyze_ + es + ' => ' + GetDateTime_ (Rec.Time));
     case WhatIsIt (True, es, Rec.Name) of
      $0D: AddMail (Addr, tmArcMail, Rec.Size, Rec.Time, Flag);
      $0E: AddMail (Addr, tmTic, Rec.Size, Rec.Time, Flag);
     else
      AddMail (Addr, tmFiles, Rec.Size, Rec.Time, Flag);
     end;
    end else ToLog (1, File_ + es + Not_ + Found_);
    FindClose (Rec);
   end;
  end;
  Close (F);
//  ToLog (3, EndFunc_ + 'Scanner.ScanLO');
 end;

 procedure Analyze (Rec: TSearchRec; Path: string);
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.Analyze ()');
  Rec.Name:= UpStr (Rec.Name);
  ToLog (1, Analyze_ + Rec.Name);
  case WhatIsIt (False, Rec.Name, Flag) of
   $00: if f then AddMail (Addr, tmFiles, Rec.Size, Rec.Time, Flag);
   $01: if not CFG^.EmptyPackAsPoll then AddMail (Addr, tmNetMail, Rec.Size, Rec.Time, Flag)
                                                              { Long NetMail }                    { Address, Size, Flag }
        else if Rec.Size <> 60 then AddMail (Addr, tmNetMail, Rec.Size, Rec.Time, Flag);
   $02: if Rec.Size > 0 then begin
         AddTime (Addr, Rec.Time, Flag);
         ScanLO (Path + Rec.Name, Flag);                      { Long LO }                         { Address, List file, Flag }
        end else if CFG^.AADateTime then AddTime (Addr, Rec.Time, Flag);
   $03: if not CFG^.SkipBusyFlag then                         { Long BUSY }                       { Address, Flag }
         if CFG^.AADateTime then AddTime (Addr, Rec.Time, Flag)
                            else AddFlag (Addr, Flag);
   $04: begin
         if F then Exit;
         F:= True;
         Analyze2 (Path + Rec.Name + '\');
         F:= False;
        end;                                                  { Long FileBoxes (The Brake!) }     { Address, Directory, Flag }
   $05: AddMail (Addr, tmRequest, Rec.Size, Rec.Time, Flag);  { Long Request }                    { Address, Size, Flag }
   $06: if not CFG^.EmptyPackAsPoll then AddMail (Addr, tmNetMail, Rec.Size, Rec.Time, Flag)
                                                              { Short NetMail }                   { Address, Size, Flag }
        else if Rec.Size <> 60 then AddMail (Addr, tmNetMail, Rec.Size, Rec.Time, Flag);
   $07: if Rec.Size > 0 then begin
         AddTime (Addr, Rec.Time, Flag);
         ScanLO (Path + Rec.Name, Flag);                      { Short LO }                        { Address, List file, Flag }
        end else if CFG^.AADateTime then AddTime (Addr, Rec.Time, Flag);
   $08: if not CFG^.SkipBusyFlag then                         { Short BUSY }                      { Address, Flag }
         if CFG^.AADateTime then AddTime (Addr, Rec.Time, Flag)
                            else AddFlag (Addr, Flag);
   $09: AddMail (Addr, tmRequest, Rec.Size, Rec.Time, Flag);  { Short Request }                   { Address, Size, Flag }
   $0A: Analyze2 (Path + Rec.Name + '\');                     { Next level }                      { Address, Next Level }
   $0B: begin
         if F then Exit;
         F:= True;
         Analyze2 (Path + Rec.Name + '\');
         F:= False;
        end;                                                  { Short FileBoxes }                 { Address, Directory, Flag }
   $0C: begin
         if F then Exit;
         F:= True;
         Analyze2 (Path + Rec.Name + '\');
         F:= False;
        end;                                                  { Long FileBoxes (T-Mail) }         { Address, Directory, Flag }
   $0D: if F then AddMail (Addr, tmArcMail, Rec.Size, Rec.Time, Flag); { ArcMail }                         { Size }
   $0E: if F then AddMail (Addr, tmTic, Rec.Size, Rec.Time, Flag);      { TIC }                             { Address, Size }
  end;
//  ToLog (3, EndFunc_ + 'Scanner.Analyze');
 end;

 procedure ScanBSO;
 var s, s2: string;
  function SetZone: boolean;
  var i: byte;
      z: word;
  begin
//   ToLog (3, ExecFunc_ + 'Scanner.ScanBSO.SetZone ()');
   SetZone:= False;
   ClearAddr (Addr);
   s2:= GetMExt (Level0^.Name.Name, s);
   if s2 = '' then Addr [0]:= CFG^.DefZone
   else begin
   if Length (s2) <> 3 then DError:= True
                       else DError:= False;
   for i:= 1 to 3 do begin
    if DError then begin
     ToLog (0, Bad_ + ScanDir_ + Name_ + Level0^.Name.Name);
//     ToLog (3, EndFunc_ + 'Scanner.ScanBSO.SetZone');
     Exit;
    end;
    case i of
     3: z:= c16to10 (s2 [i]);
     2: z:= 16 * c16to10 (s2 [i]);
     1: z:= 256 * c16to10 (s2 [i]);
    end;
    Addr [0]:= Addr [0] + z;
   end;
  end;
  Addr2:= Addr;
  Str (Addr2 [0], s);
  ToLog (2, SetZone_ + s + ForScan_ + ScanDir_ + ' ' +
        Copy (CFG^.BSO, 1, Length (CFG^.BSO) - 1) + GetExt (Level0^.Name.Name, s2) + '\');
  SetZone:= True;
//  ToLog (3, EndFunc_ + 'Scanner.ScanBSO.SetZone');
 end;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.ScanBSO ()');
  AL:= 0;
  ScanDir (Copy (CFG^.BSO, 1, Length (CFG^.BSO) - 1), '.*', $10, Level0);
  if Level0 = nil then begin
//   ToLog (3, EndFunc_ + 'Scanner.ScanBSO');
   Exit;
  end;
  while Level0^.Next <> nil do begin
   if SetZone then Analyze1 (Copy (CFG^.BSO, 1, Length (CFG^.BSO) - 1) + GetExt (Level0^.Name.Name, s) + '\');
   Level0:= Level0^.Next;
  end;
  if SetZone then Analyze1 (Copy (CFG^.BSO, 1, Length (CFG^.BSO) - 1) + GetExt (Level0^.Name.Name, s) + '\');
  KillDir (Level0);
//  ToLog (3, EndFunc_ + 'Scanner.ScanBSO');
 end;

 procedure ScanFBs;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.ScanFBs ()');
  with CFG^ do if (BSO = FileBoxes) then begin
//   ToLog (3, EndFunc_ + 'Scanner.ScanFBs');
   Exit;
  end else Analyze1 (FileBoxes);
//  ToLog (3, EndFunc_ + 'Scanner.ScanFBs');
 end;

 procedure ScanLBSO;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.ScanLBSO ()');
  with CFG^ do if (LongBSO = BSO) or
                  (LongBSO = FileBoxes) then begin
//   ToLog (3, EndFunc_ + 'Scanner.ScanLBSO');
   Exit;
  end else Analyze1 (LongBSO);
//  ToLog (3, EndFunc_ + 'Scanner.ScanLBSO');
 end;

 procedure ScanLFBs;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.ScanLFBs ()');
  with CFG^ do if (LongFileBoxes = BSO) or
                  (LongFileBoxes = FileBoxes) or
                  (LongFileBoxes = LongBSO) then begin
//   ToLog (3, EndFunc_ + 'Scanner.ScanLFBs');
   Exit;
  end else Analyze1 (LongFileBoxes);
//  ToLog (3, EndFunc_ + 'Scanner.ScanLFBs');
 end;

 procedure ScanBoxes;
 begin
//  ToLog (3, ExecFunc_ + 'Scanner.ScanBoxes ()');
  ToLog (0, Scan_ + ScanFB_ + ' and ' + ScanBSO_ + ScanDir_);
  F:= False;
  if CFG^.BSO <> '' then ScanBSO;
  if CFG^.FileBoxes <> '' then ScanFBs;
  if CFG^.LongBSO <> '' then ScanLBSO;
  if CFG^.LongFileBoxes <> '' then ScanLFBs;
//  ToLog (3, EndFunc_ + 'Scanner.ScanBoxes');
 end;

end.
