unit Sort;

interface

 uses Queue, Types, Config, Aliases, Messages, Log;

 procedure SortingData;

implementation

 var Q1, Q2: pQueue;
     Q3    : tQueue;

 procedure EQU;
 begin
  Q3:= Q1^;
  Q1^.Addr:= Q2^.Addr;
  Q1^.Date:= Q2^.Date;
  Q1^.Time:= Q2^.Time;
  Q1^.NM:= Q2^.NM;
  Q1^.AM:= Q2^.AM;
  Q1^.FM:= Q2^.FM;
  Q1^.NF:= Q2^.NF;
  Q1^.AF:= Q2^.AF;
  Q1^.FF:= Q2^.FF;
  Q1^.Flag:= Q2^.Flag;
  Q3.Prev:= Q2^.Prev;
  Q3.Next:= Q2^.Next;
  Q2^:= Q3;
 end;

 procedure SortBySize;
 begin
  Q1:= Q;
  while Q1^.Next <> nil do begin
   Q2:= Q1^.Next;
   while Q2 <> nil do begin
    if Q1^.NM+Q1^.AM+Q1^.FM < Q2^.NM+Q2^.AM+Q2^.FM then EQU;
    Q2:= Q2^.Next;
   end;
   Q1:= Q1^.Next;
  end;
 end;

 function CompareAddress: boolean; {True if address in Q2 > address in Q1}
 begin
  CompareAddress:= False;
  if Q2^.Addr [0] < Q1^.Addr [0] then CompareAddress:= True
  else if Q2^.Addr [0] = Q1^.Addr [0] then
   if Q2^.Addr [1] < Q1^.Addr [1] then CompareAddress:= True
   else if Q2^.Addr [1] = Q1^.Addr [1] then
    if Q2^.Addr [2] < Q1^.Addr [2] then CompareAddress:= True
    else if Q2^.Addr [2] = Q1^.Addr [2] then
     if Q2^.Addr [3] < Q1^.Addr [3] then CompareAddress:= True;
 end;

 procedure SortByNode;
 begin
  Q1:= Q;
  while Q1^.Next <> nil do begin
   Q2:= Q1^.Next;
   while Q2 <> nil do begin
    if CompareAddress then EQU;
    Q2:= Q2^.Next;
   end;
   Q1:= Q1^.Next;
  end;
 end;

 procedure SortByDays (A: byte);
  function CompareDate (HM: boolean): integer; {if date2 < date1 then true}
  begin
   CompareDate:= -1;
   if Q1^.Date.Y > Q2^.Date.Y then CompareDate:= 1
   else if Q1^.Date.Y = Q2^.Date.Y then
    if Q1^.Date.M > Q2^.Date.M then CompareDate:= 1
    else if Q1^.Date.M = Q2^.Date.M then
     if Q1^.Date.D > Q2^.Date.D then CompareDate:= 1
     else if Q1^.Date.D = Q2^.Date.D then
      if HM then
       if Q1^.Time.H > Q2^.Time.H then CompareDate:= 1
       else if Q1^.Time.H = Q2^.Time.H then
        if Q1^.Time.M > Q2^.Time.M then CompareDate:= 1
        else if Q1^.Time.M = Q2^.Time.M then
         if Q1^.Time.S > Q2^.Time.S then CompareDate:= 1
         else CompareDate:= 0
        else
       else
      else CompareDate:= 0;
  end;
 begin
  Q1:= Q;
  while Q1^.Next <> nil do begin
   Q2:= Q1^.Next;
   while Q2 <> nil do begin
    case A of
     0: if CompareDate (True) = 1 then EQU;
     1: case CompareDate (False) of
         0: if Q1^.NM+Q1^.AM+Q1^.FM < Q2^.NM+Q2^.AM+Q2^.FM then EQU;
         1: EQU;
        end;
     2: case CompareDate (False) of
         0: if CompareAddress then EQU;
         1: EQU;
        end;
    end;
    Q2:= Q2^.Next;
   end;
   Q1:= Q1^.Next;
  end;
 end;

 procedure SortingData;
 begin
  ToLog (1, Sort_);
  if Q = nil then Exit;
  while Q^.Prev <> nil do Q:= Q^.Prev;
  SortByNode;
  case CFG^.Sorting of
   60: SortBySize;
   62: SortByDays (0);
   63: SortByDays (1);
   64: SortByDays (2);
  end;
  while Q^.Prev <> nil do Q:= Q^.Prev;
 end;

end.
