unit StdFunc;

interface

 uses Messages, Types, FileNms, Errors, WriteF, SysUtils;

 function Date: string;
 function Time: string;
 function GetDateTime (Year, Month, Day, Hour, Min, Sec: word): string;
 function GetDateTime_ (Time: longint): string;


 function ProgramPath: string;


 function DelFirstSpace (Str: string): string;
 function DelLastSpace (Str: string): string;
 function DelComment (Str: string): string;
 function ConvertTabs (Str: string): string;

 function UpStr (Str: string): string;

 function DwordToStr (DW: longint): string;

 function SizeToStr (Size: longint; Separator: string; Format: byte): string;  {0 = b, 1 = Kb, 2 = Mb}
 function SizeToStrD (Size: comp; Separator: string; Format: byte): string;  {0 = b, 1 = Kb, 2 = Mb}

 function CheckMemory (Size1, Size2: longint): boolean;


 function GetExt (Data: string; var NewData: string): string;
 function GetMExt (Data: string; var NewData: string): string;


 procedure WriteErrStr (Num: word; Str: string);
 procedure ErrHalt (Code: word; Str: string);


 procedure ScanDir (Path, Mask: string; Attr: byte; var List: pDirList);
 procedure KillDir (var List: pDirList);


 var DError: boolean;
 function c32to10 (Code: char): byte;
 function c16to10 (Code: char): byte;


 procedure ClearAddr (var Addr: t4D);
 function ShowAddr (Addr: t4D): string;

implementation

 uses Config, Log;

{-------------------------------------------------------------------------}

 function Time: string;
 begin
  LongTimeFormat:= 'HH:MM:SS';
  Time:= TimeToStr (SysUtils.Time);
 end;

 function Date: string;
 begin
  ShortDateFormat:= 'dd.mm.yy';
  Date:= DateToStr (SysUtils.Date);
 end;

 function GetDateTime (Year, Month, Day, Hour, Min, Sec: word): string;
  function Conv (Z: word): string;
  var s: string;
  begin
//   ToLog (3, ExecFunc_ + 'StdFunc.GetDateTime.Conv ()');
   Str (Z, s);
   if Length (s) <> 2 then s:= '0' + s;
   Conv:= s;
//   ToLog (3, EndFunc_ + 'StdFunc.GetDateTime.Conv');
  end;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.GetDateTime ()');
  GetDateTime:= Conv(Hour)+':'+Conv(Min)+':'+Conv(Sec)+'  '+Conv(Day)+'/'+Conv(Month)+'/'+IntToStr(Year);
//  ToLog (3, EndFunc_ + 'StdFunc.GetDateTime');
 end;

 function GetDateTime_ (Time: longint): string;
 var Year, Month, Day: word;
     Hour, Min, Sec, MSec: word;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.GetDateTime_ ()');
  DecodeDate (FileDateToDateTime (Time), Year, Month, Day);
  DecodeTime (FileDateToDateTime (Time), Hour, Min, Sec, MSec);
  GetDateTime_:= GetDateTime (Year, Month, Day, Hour, Min, Sec);
//  ToLog (3, EndFunc_ + 'StdFunc.GetDateTime_');
 end;

{-------------------------------------------------------------------------}

 function ProgramPath: string;
 begin
  ProgramPath:= ExtractFileDir (ParamStr (0)) + '\';
 end;

{-------------------------------------------------------------------------}

 function DelFirstSpace (Str: string): string;
 var i: word;
 begin
  DelFirstSpace:= '';
  if Str = '' then Exit;
  i:= 1;
  while (Str [i] = ' ') and (i < Length (Str)) do Inc (i);
  DelFirstSpace:= Copy (Str, i, Length (Str) - i + 1);
 end;

{-------------------------------------------------------------------------}

 function DelLastSpace (Str: string): string;
 var i: word;
 begin
  i:= Length (Str);
  DelLastSpace:= '';
  if i = 0 then Exit;
  while (Str [i] = ' ') and (i > 0) do Dec (i);
  if i <> 0 then DelLastSpace:= Copy (Str, 1, i);
 end;

 function DelComment (Str: string): string;
 var i: word;
 begin
  DelComment:= '';
  if (Str = '') or (Str [1] = ';') then Exit;
  i:= 1;
  while (Str [i] <> ';') and (i < Length (Str)) do Inc (i);
  if Str [i] = ';' then Dec (i);
  DelComment:= Copy (Str, 1, i);
 end;

 function ConvertTabs (Str: string): string;
 var i: word;
 begin
  i:= 1;
  while i < Length (Str) do begin
   if Str [i] = #9 then Str [i]:= ' ';
   inc (i);
  end;
  ConvertTabs:= Str;
 end;

 function UpStr (Str: string): string;
 var i: byte;
 begin
  for i:= 1 to Length (Str) do
   if (byte (Str [i]) >= $61) and (byte (Str [i]) <= $7A) then
    Str [i]:= char (byte (Str [i]) - $20);
  UpStr:= Str;
 end;

 function DWordToStr (DW: longint): string;
 const Res: string [13] = '0';
 begin
  asm
   push  ecx
   push  ebx
   push  esi
   mov	 ebx,10
   mov	 ecx,0
   mov	 eax,DW
  @@1:
   mov	 edx,0
   div	 ebx
   push  edx
   inc	 ecx
   cmp	 eax,0
   jnz	 @@1
   lea	 esi,Res
   mov	 [esi],cl
   inc	 esi
  @@2:
   pop	 eax
   add	 al,30h
   mov	 [esi],al
   inc	 esi
   loop  @@2
   pop	 esi
   pop	 ebx
   pop	 ecx
  end;
  DwordToStr:= Res;
 end;

 function SizeToStr (Size: longint; Separator: string; Format: byte): string;  {0 = b, 1 = Kb, 2 = Mb}
 var s1, s2: string;
     z1, z2, z3: integer;
  procedure SetSepar;
  var i, j: byte;
      s   : string;
  begin
   if Length (s1) < 3 then Exit;
   s:= '';
   j:= 1;
   for i:= 1 to Length (s1) do
    begin
     s:= s1 [Length (s1) - i + 1] + s;
     Inc (j);
     if (3 * Trunc (j / 4) = i) and
	(i < Length (s1)) then
      begin
       s:= Separator + s;
       Inc (j);
      end;
    end;
   s1:= s;
  end;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.SizeToStr ()');
  z1:= Trunc (Size / 1024);
  if Trunc ((Size / 1024 - z1) * 10) > 4 then Inc (z1);
  case Format of
   0: s1:= DWordToStr (Size);
   1: s1:= DWordToStr (z1);
   2: begin
       z2:= Trunc (z1 / 1024);
       s1:= DWordToStr (z2);
       z3:= Trunc ((z1 / 1024 - z2) * 100);
       if Trunc (((z1 / 1024 - z2) * 100 - z1) * 10) > 4 then Inc (z1);
       s2:= DWordToStr (z3);
      end;
  end;
  if Separator <> '' then SetSepar;
  if Format = 2 then
   begin
    if Length (s2) <> 2 then s2:= '0' + s2;
    s1:= s1 + ',' + s2;
   end;
  SizeToStr:= s1;
//  ToLog (3, ExecFunc_ + 'StdFunc.SizeToStr');
 end;

 function SizeToStrD (Size: comp; Separator: string; Format: byte): string;  {0 = b, 1 = Kb, 2 = Mb}
 var s1: string;
     s2: string;
     z1: comp;
     z2: comp;
     z : byte absolute z2;
     m : byte;
  procedure SetSepar;
  var i, j: byte;
      s   : string;
  begin
   if Length (s1) < 3 then Exit;
   s:= '';
   j:= 1;
   for i:= 1 to Length (s1) do
    begin
     s:= s1 [Length (s1) - i + 1] + s;
     Inc (j);
     if (3 * Trunc (j / 4) = i) and
	(i < Length (s1)) then
      begin
       s:= Separator + s;
       Inc (j);
      end;
    end;
   s1:= s;
  end;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.SizeToStrD ()');
  s1:= '';
  case Format of
  0: z1:= Size;
  1: z1:= Trunc (Size / 1024);
  2: begin
      z1:= Trunc (Size / 1048576);
      m:= Trunc (((Size - z1 * 1048576) / 1048576) * 100);
     end;
  end;
  while z1 <> 0 do begin
   z2:= z1 - 10 * Trunc (z1 / 10);
   z1:= Trunc (z1 / 10);
   s1:= char (z + $30) + s1;
  end;
  if s1 = '' then s1:= '0';
  if Separator <> '' then SetSepar;
  if Format = 2 then
   begin
    Str (m, s2);
    if Length (s2) <> 2 then s2:= '0' + s2;
    s1:= s1 + ',' + s2;
   end;
  SizeToStrD:= s1;
//  ToLog (3, ExecFunc_ + 'StdFunc.SizeToStrD');
 end;

 function CheckMemory (Size1, Size2: longint): boolean;
 assembler;
  asm
   mov eax,Size1
   and eax,7FFFFFFFh
   mov ebx,Size2
   cmp eax,ebx
   mov eax,1
   jg  @@1
   mov eax,0
  @@1:
  end;

{-------------------------------------------------------------------------}

 function GetExt (Data: string; var NewData: string): string;
 var i: word;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.GetExt ()');
  i:= Length (Data);
  GetExt:= '';
  NewData:= Data;
  while (i > 1) and (Data [i] <> '.') do
   begin
    if Data [i] = '\' then Exit;
    Dec (i);
   end;
  if i > 1 then
   begin
    GetExt:= Copy (Data, i, Length (Data) - i + 1);
    NewData:= Copy (Data, 1, i - 1);
   end
  else
   begin
    GetExt:= '';
    NewData:= Data;
   end;
//  ToLog (3, EndFunc_ + 'StdFunc.GetExt');
 end;

 function GetMExt (Data: string; var NewData: string): string;
 var s: string;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.GetMExt ()');
  s:= GetExt (Data, NewData);
  if s <> '' then GetMExt:= Copy (s, 2, Length (s) - 1)
	     else GetMExt:= s;
//  ToLog (3, EndFunc_ + 'StdFunc.GetMExt');
 end;

{-------------------------------------------------------------------------}

 procedure WriteErrStr (Num: word; Str: string);
 begin
  System.Write (#7);
  Writeln (Pref_ + AlNameErr + IntToStr (Num));
  Writeln (Pref2_ + Str);
 end;

 procedure ErrHalt (Code: word; Str: string);
 begin
  if Str <> '' then Writeln (Pref2_ + Str);
  DoneLogFile;
  System.Write (#7#7);
  Halt (Code);
 end;

{-------------------------------------------------------------------------}

 procedure ScanDir (Path, Mask: string; Attr: byte; var List: pDirList);
 var
  SR: TSearchRec;
  Result: integer;
  S: string;
  b: boolean;
  procedure AddItem;
  begin
//   ToLog (3, ExecFunc_ + 'StdFunc.ScanDir.AddItem ()');
   ToLog (2, 'F' + Copy (Found_, 2, 4) + ' ' + SR.Name);
{$ifndef Win32}
   if not CheckMemory (MemAvail, SizeOf (tDirList)) then
    begin
     ToLog (0, NoMem);
     DoneLogFile;
     DoneConfigFile;
     ErrHalt (esNoMemory, NoMem);
    end;
{$endif}
   if List = nil then
    begin
     List:= New (pDirList);
     List^.Prev:= nil;
    end
   else
    begin
     List^.Next:= New (pDirList);
     List^.Next^.Prev:= List;
     List:= List^.Next;
    end;
   List^.Next:= nil;
   List^.Name:= SR;
   if UpStr (SR.Name) = S then b:= True;
//   ToLog (3, EndFunc_ + 'StdFunc.ScanDir.AddItem');
  end;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.ScanDir ()');
  List:= nil;
  ToLog (2, Scan_ + Path + Mask);
  b:= False;
  S:= UpStr (ExtractFileName (Path));
  SetLength (S, Length (S) - Length (ExtractFileExt (S)));
  Result:= FindFirst (Path + Mask, Attr, SR);
  while Result = 0 do
   begin
    if SR.Name <> nBad1 then
     if SR.Name <> nBad2 then AddItem;
    Result:= FindNext (SR);
   end;
  if Result = 3 then ToLog (0, Path_ + ScanDir_ + ' ' + Path + Not_ + Found_)
  else begin
   FindClose (SR);
   if not b and (S <> '') then begin
    SR.Name:= S;
    SR.Attr:= Attr;
    SR.Size:= 0;
    SR.Time:= 0;
    AddItem;
   end;
  end;
  if List <> nil then
   while List^.Prev <> nil do List:= List^.Prev;
//  ToLog (3, EndFunc_ + 'StdFunc.ScanDir');
 end;

 procedure KillDir (var List: pDirList);
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.KillDir ()');
  if List = nil then Exit;
  while List^.Prev <> nil do List:= List^.Prev;
  while List^.Next <> nil do
   begin
    List:= List^.Next;
    Dispose (List^.Prev);
   end;
  Dispose (List);
  List:= nil;
//  ToLog (3, EndFunc_ + 'StdFunc.KillDir');
 end;

{-------------------------------------------------------------------------}

 function c32to10 (Code: char): byte;
 assembler;
 asm
{$ifndef Win32}
  xor eax,eax
  mov al,Code
{$endif}
  cmp al,5ah
  jle @@1
  sub al,20h
  cmp al,5ah
  jg  @@Err
  cmp al,41h
  jl  @@Err
 @@1:
  cmp al,30h
  jl  @@Err
  cmp al,39h
  jle @@Ok1
  cmp al,41h
  jge @@Ok2
 @@Err:
  mov DError,1
  mov eax,-1
  jmp @@2
 @@Ok1:
  sub al,30h
  jmp @@2
 @@Ok2:
  sub al,37h
 @@2:
 end;

 function c16to10 (Code: char): byte;
 assembler;
 asm
{$ifndef Win32}
  xor eax,eax
  mov al,Code
{$endif}
  cmp al,46h
  jle @@1
  sub al,20h
  cmp al,46h
  jg  @@Err
  cmp al,41h
  jl  @@Err
 @@1:
  cmp al,30h
  jl  @@Err
  cmp al,39h
  jle @@Ok1
  cmp al,41h
  jge @@Ok2
 @@Err:
  mov DError,1
  mov eax,-1
  jmp @@2
 @@Ok1:
  sub al,30h
  jmp @@2
 @@Ok2:
  sub al,37h
 @@2:
 end;

{-------------------------------------------------------------------------}

 procedure ClearAddr (var Addr: t4D);
 var i: byte;
 begin
  for i:= 0 to 3 do Addr [i]:= 0;
 end;

 function ShowAddr (Addr: t4D): string;
 var s1, s2: string;
     i: byte;
 begin
//  ToLog (3, ExecFunc_ + 'StdFunc.ShowAddr ()');
  S1:= '';
  for i:= 0 to 3 do
   begin
    Str (Addr [i], s2);
    case i of
     1: s1:= s1 + ':';
     2: s1:= s1 + '/';
     3: s1:= s1 + '.';
    end;
    s1:= s1 + s2;
   end;
  ShowAddr:= s1;
//  ToLog (3, ExecFunc_ + 'StdFunc.ShowAddr');
 end;

end.
