unit TMailQ;

interface

 uses WriteF, Log, Queue, Config, FileNms, SysUtils, Errors, Messages, StdFunc, Types;

 procedure ScanTMailNetMail;

implementation

 procedure ScanPackets;
  function Request (SR: tSearchRec; var Date: longint): longint;
  var R: integer;
  begin
//   ToLog (3, ExecFunc_ + 'TMailQ.ScanPackets.Requests ()');
   Request:= 0;
   Date:= DateTimeToFileDate (Now);
   R:= FindFirst (CFG^.Packets + Copy (SR.Name, 1, Length (SR.Name) - Length (ExtractFileExt (SR.Name))) + '.' + fREQ, $27, SR);
   if R = 0 then begin
    Date:= SR.Time;
    Request:= SR.Size;
   end;
   FindClose (SR);
//   ToLog (3, EndFunc_ + 'TMailQ.ScanPackets.Requests');
  end;
  procedure Analyse (SR: tSearchRec; Flag: string);
  var Buf: array [0..59] of char;
      DAZ, DAR, DAN, DAP: word;
      Addr: t4D;
      F, R: longint;
  begin
//   ToLog (3, ExecFunc_ + 'TMailQ.ScanPackets.Analyze ()');
   ToLog (1, Analyze_ + SR.Name);
   if SR.Size < 60 then begin
    ToLog (1, Bad_ + File__ + SR.Name);
    Exit;
   end;
   F:= FileOpen (CFG^.Packets + SR.Name, fmOpenRead + fmShareDenyNone);
   if F <= 0 then begin
    ToLog (1, File_ + SR.Name + Not_ + Found_);
    Exit;
   end;
   R:= FileRead (F, Buf, 60);
   FileClose (F);
   asm
    push esi
    push edi
    lea esi,Buf
    mov ax,[esi + 02h]
    mov DAN,ax
    mov ax,[esi + 16h]
    mov DAR,ax
    mov ax,[esi + 24h]
    mov DAZ,ax
    mov ax,[esi + 34h]
    mov DAP,ax
    pop edi
    pop esi
   end;
   Addr [0]:= DAZ; Addr [1]:= DAR; Addr [2]:= DAN; Addr [3]:= DAP;
   ToLog (1, Decode_ + ShowAddr (Addr));
   if not CFG^.EmptyPackAsPoll then AddMail (Addr, tmNetMail, SR.Size, SR.Time, Flag)
   else if SR.Size <> 60 then AddMail (Addr, tmNetMail, SR.Size, SR.Time, Flag);
   if Flag = 'R' then begin
    R:= Request (SR, F);
    AddMail (Addr, tmRequest, R, F, Flag);
   end;
//   ToLog (3, EndFunc_ + 'TMailQ.ScanPackets.Analyze');
  end;
  procedure ScanExt (Ext, Flag: string);
  var Res: integer;
      SR : tSearchRec;
  begin
//   ToLog (3, ExecFunc_ + 'TMailQ.ScanPackets.ScanExt ()');
   Res:= FindFirst (CFG^.Packets + '*.' + Ext, $27, SR);
   while Res = 0 do begin
    if SR.Attr and $10 = 0 then Analyse (SR, Flag);
    Res:= FindNext (SR);
   end;
   FindClose (SR);
//   ToLog (3, EndFunc_ + 'TMailQ.ScanPackets.ScanExt');
  end;
 begin
//  ToLog (3, ExecFunc_ + 'TMailQ.ScanPackets ()');
  ToLog (0, TMail_ + TPackets_ + ScanDir_);
  ScanExt (ePKT, 'N');
  ScanExt (ePKH, 'H');
  ScanExt (ePKR, 'R');
//  ToLog (3, EndFunc_ + 'TMailQ.ScanPackets');
 end;

 procedure ScanTMailNetMail;
 begin
//  ToLog (3, ExecFunc_ + 'TMailQ.ScanTMailNetMail ()');
  if CFG^.Packets <> '' then ScanPackets;
//  ToLog (3, EndFunc_ + 'TMailQ.ScanTMailNetMail');
 end;

end.
