unit PKT;

interface

 uses Config, MSG, Types, StdFunc, Aliases, Messages, SysUtils;

 type
  pPKT = ^tPKT;
  tPKT = object (tBase)
   SubHead: pBuf;
   SubHeadLen: word;
   constructor Init;
   destructor  Done;
   procedure   Run;	    virtual;
   procedure   CreateHead;  virtual;
   procedure   WriteHead;   virtual;
   procedure   WriteKludge; virtual;
   procedure   CloseBase;   virtual;
  private
   function    FlNm: string;
   function    Conv (D: byte): string;
  end;

implementation

 const
  PktE : string [4] = '.PKT';
  kArea: string [5] = 'AREA:';

 constructor tPKT.Init;
 var i: byte;
 begin
  inherited Init (58, FlNm);
  SubHeadLen:= 37 + Length (CFG^.ToName) + Length (CFG^.FromName) + Length (CFG^.Subject);
  GetMem (SubHead, SubHeadLen);
  FillChar (SubHead^ [0], SubHeadLen, 0);
 end;

 destructor tPKT.Done;
 begin
  FreeMem (SubHead, SubHeadLen);
  inherited Done;
 end;

 procedure tPKT.Run;
 begin
  CreateHead;
  inherited Run;
 end;

 procedure tPKT.CreateHead;
 var i, j: byte;
     s	 : string;
     DS, MM, YH, T: word;
 begin
  i:= 0;
  Head^ [i]:= Lo (CFG^.FromAddress [2]);
  Head^ [i + 1]:= Hi (CFG^.FromAddress [2]);
  Head^ [i + 2]:= Lo (CFG^.ToAddress [2]);
  Head^ [i + 3]:= Hi (CFG^.ToAddress [2]);
  DecodeDate (SysUtils.Date, YH, MM, DS);
  Dec (MM);
  Head ^[i + 4]:= Lo (YH);
  Head ^[i + 5]:= Hi (YH);
  Head ^[i + 6]:= Lo (MM);
  Head ^[i + 8]:= Lo (DS);
  DecodeTime (Time, YH, MM, DS, T);
  Head ^[i + 10]:= Lo (YH);
  Head ^[i + 12]:= Lo (MM);
  Head ^[i + 14]:= Lo (DS);
  Head^ [i + 18]:= 2;
  if (CFG^.FromAddress [3] <> 0) and (CFG^.Area.Name = sNetMail) then begin
   Head^ [i + 20]:= $FF;
   Head^ [i + 21]:= $FF;
   Head^ [i + 16]:= $60;
   Head^ [i + 17]:= $09;
   Head^ [i + 38]:= Lo (CFG^.FromAddress [1]);
   Head^ [i + 39]:= Hi (CFG^.FromAddress [1]);
  end else begin
   Head^ [i + 20]:= Lo (CFG^.FromAddress [1]);
   Head^ [i + 21]:= Hi (CFG^.FromAddress [1]);
  end;
  Head^ [i + 22]:= Lo (CFG^.ToAddress [1]);
  Head^ [i + 23]:= Hi (CFG^.ToAddress [1]);
  for i:= 1 to Length (CFG^.Area.Password) do Head^ [25 + i]:= byte (CFG^.Area.Password [i]);
  i:= 34;
  Head^ [i]:= Lo (CFG^.FromAddress [0]);
  Head^ [i + 1]:= Hi (CFG^.FromAddress [0]);
  Head^ [i + 2]:= Lo (CFG^.ToAddress [0]);
  Head^ [i + 3]:= Hi (CFG^.ToAddress [0]);
  Head^ [i + 7]:= 1;
  Head^ [i + 10]:= 1;
  Head^ [i + 12]:= Lo (CFG^.FromAddress [0]);
  Head^ [i + 13]:= Hi (CFG^.FromAddress [0]);
  Head^ [i + 14]:= Lo (CFG^.ToAddress [0]);
  Head^ [i + 15]:= Hi (CFG^.ToAddress [0]);
  Head^ [i + 16]:= Lo (CFG^.FromAddress [3]);
  Head^ [i + 17]:= Hi (CFG^.FromAddress [3]);
  Head^ [i + 18]:= Lo (CFG^.ToAddress [3]);
  Head^ [i + 19]:= Hi (CFG^.ToAddress [3]);
  for i:= 4 to 7 do Head^ [50 + i]:= byte (PrgVer [i]);
  i:= 0;
  SubHead^ [i]:= 2;
  SubHead^ [i + 2]:= Lo (CFG^.FromAddress [2]);
  SubHead^ [i + 3]:= Hi (CFG^.FromAddress [2]);
  SubHead^ [i + 4]:= Lo (CFG^.ToAddress [2]);
  SubHead^ [i + 5]:= Hi (CFG^.ToAddress [2]);
  SubHead^ [i + 6]:= Lo (CFG^.FromAddress [1]);
  SubHead^ [i + 7]:= Hi (CFG^.FromAddress [1]);
  SubHead^ [i + 8]:= Lo (CFG^.ToAddress [1]);
  SubHead^ [i + 9]:= Hi (CFG^.ToAddress [1]);
//  SubHead^ [i + 10]:= 1;
  s:= GetDT;
  for i:= 1 to 19 do SubHead^ [13 + i]:= byte (s [i]);
  j:= 33;
  for i:= 1 to Length (CFG^.ToName) do SubHead^ [j + i]:= byte (CFG^.ToName [i]);
  j:= j + Length (CFG^.ToName) + 1;
  for i:= 1 to Length (CFG^.FromName) do SubHead^ [j + i]:= byte (CFG^.FromName [i]);
  j:= j + Length (CFG^.FromName) + 1;
  for i:= 1 to Length (CFG^.Subject) do SubHead^ [j + i]:= byte (CFG^.Subject [i]);
 end;

 procedure tPKT.WriteHead;
 var i: byte;
 begin
  inherited WriteHead;
  for i:= 0 to SubHeadLen - 1 do WriteString (char (SubHead^ [i]));
 end;

 procedure tPKT.WriteKludge;
 begin
  if CFG^.Area.Name = sNetMail then begin
   WriteINTL;
   WriteMSGID;
   WritePID;
   WriteFMPT;
   WriteTOPT;
  end else begin
   WriteString (kArea + UpStr (CFG^.Area.Name) + #13);
   WriteMSGID;
   WritePID;
   WriteTID;
  end;
  inherited WriteKludge;
 end;

 procedure tPKT.CloseBase;
 begin
  if not Error then WriteSeenBy;
  if not Error then WritePath;
  WriteString (#0#0#0);
  inherited CloseBase;
 end;

 function tPKT.FlNm: string;
 var DH, MM, YS, T: word;
     s: string;
 begin
  s:= '';
  DecodeDate (Date, YS, MM, DH);
  s:= Conv (DH);
  DecodeTime (Time, DH, MM, YS, T);
  s:= s + Conv (DH) + Conv (MM) + Conv (YS);
  FlNm:= CFG^.Area.Path + '\' + s + PktE;
 end;

 function tPKT.Conv (D: byte): string;
 var i, w: byte;
     s	 : string;
 begin
  s:= '';
  for i:= 0 to 1 do begin
   w:= (D shr (4 * i))and $0F;
   case w of
    0..9  : s:= s + char (w + $30);
    10..15: s:= s + char (w + 55);
   end;
  end;
  Conv:= s;
 end;

end.
