unit WriteF;

interface

{$ifdef Win32}
 uses Windows;
{$else}
 uses CRT;
{$endif}

 procedure Write (Str: string);
 procedure Writeln (Str: string);

implementation

{$ifdef Win32}
 var
  hConsoleOutput : THandle;
  TextAttr: byte;

PROCEDURE TextBackground(CONST Color : Word);
BEGIN
  TextAttr:= (Color SHL 4) or (TextAttr and $F);
  SetConsoleTextAttribute (hConsoleOutput, TextAttr);
END;

PROCEDURE TextColor(CONST Color : Word);
BEGIN
  TextAttr:= (Color and $f) or (TextAttr and $F0);
  SetConsoleTextAttribute(hConsoleOutput, TextAttr);
END;
{$endif}

 procedure Write (Str: string);
 var i: byte;
     f: boolean;
 begin
  if Str = '' then Exit;
  f:= False;
  for i:= 1 to Length (Str) do
   begin
    if not f then
     if Str [i] = #0 then f:= True
                     else System.Write (Str [i])
    else
     begin
      TextColor (byte (Str [i]) and $8F);
      TextBackGround ((byte (Str [i]) and $70) shr 4);
      f:= False;
     end;
   end;
  TextColor (7);
  TextBackGround (0);
 end;

 procedure Writeln (Str: string);
 begin
  Write (Str);
  System.Writeln;
 end;

{$ifdef Win32}
 procedure Init;
 begin
  hConsoleOutput := GetStdHandle(STD_OUTPUT_HANDLE);
  TextAttr:= $7;
 end;

initialization
 Init;
{$endif}
end.
